% COMSOL Multiphysics Model M-file
% Generated by COMSOL 3.5a (COMSOL 3.5.0.603, $Date: 2008/12/03 17:02:19 $)
% Some geometry objects are stored in a separate file.
% The name of this file is given by the variable 'flbinaryfile'.

flclear fem

% COMSOL version
clear vrsn
vrsn.name = 'COMSOL 3.5';
vrsn.ext = 'a';
vrsn.major = 0;
vrsn.build = 603;
vrsn.rcs = '$Name:  $';
vrsn.date = '$Date: 2008/12/03 17:02:19 $';
fem.version = vrsn;

flbinaryfile='BEM_sphere_SRR.mphm';

% Geometry
clear draw
g1=flbinary('g1','draw',flbinaryfile);
draw.s.objs = {g1};
draw.s.name = {'Sphere'};
draw.s.tags = {'g1'};
fem.draw = draw;
fem.geom = geomcsg(fem);
fem.mesh = flbinary('m1','mesh',flbinaryfile);

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'FlPDEWBoundary';
appl.assignsuffix = '_wb';
clear bnd
bnd.dweak = 'ut*test(u)';
bnd.weak = 'surfint2*test(u)';
bnd.ind = [1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.border = 1;
fem.outform = 'weak';

% Coupling variable elements
clear elemcpl
% Integration coupling variables
clear elem
elem.elem = 'elcplscalar';
elem.g = {'1'};
src = cell(1,1);
clear bnd
bnd.expr = {{ ...
  '-1/(2*pi)*u*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  '1/(2*pi)*u*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  {'u/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2))', ...
  'u/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2))'},{ ...
  'u*(x-dest(x))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(x-dest(x))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  'u*(y-dest(y))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(y-dest(y))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  'u*(z-dest(z))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(z-dest(z))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  '(Ex*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nx*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ex*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nx*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ey*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-ny*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ey*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-ny*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ez*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nz*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ez*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nz*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ey*nz-Ez*ny)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ey*nz-Ez*ny)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ez*nx-Ex*nz)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ez*nx-Ex*nz)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ex*ny-Ey*nx)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ex*ny-Ey*nx)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '1/(2*pi)*u*(dest(nx)*(x-dest(x))+dest(ny)*(y-dest(y))+dest(nz)*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  '-1/(2*pi)*u*(dest(nx)*(x-dest(x))+dest(ny)*(y-dest(y))+dest(nz)*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}};
bnd.ipoints = {{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4', ...
  '4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'}};
bnd.frame = {{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz', ...
  'xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'}, ...
  {'xyz','xyz'},{'xyz','xyz'}};
bnd.ind = {{'1','2','3','4','5','6','7'},{'8'}};
src{1} = {{},{},bnd,{}};
elem.src = src;
geomdim = cell(1,1);
clear bnd
bnd.usage = {{},{},{},{},{},{},{},{},{},{},{},{'1'}};
bnd.ind = {{'1','2','3','4','5','6','7','8'}};
geomdim{1} = {{},{},bnd,{}};
elem.geomdim = geomdim;
elem.var = {'surfint','phi','Ex','Ey','Ez','E2x','E2y','E2z','Hx','Hy', ...
  'Hz','surfint2'};
elem.global = {'1','2','3','4','5','6','7','8','9','10','11'};
elem.maxvars = {};
elemcpl{1} = elem;
fem.elemcpl = elemcpl;

% Functions
clear fcns
fcns{1}.type='inline';
fcns{1}.name='nonzero(x)';
fcns{1}.expr='((x)+((x)==0))';
fcns{1}.dexpr={'1'};
fcns{1}.complex='true';
fem.functions = fcns;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem, ...
                     'linshape',[], ...
                     'dofversion',1);

% Retrieve solution
fem.sol=flbinary('sol1','solution',flbinaryfile);

% Save current fem structure for restart purposes
fem0=fem;

% (Default values are not included)

% Application mode 1
clear appl
appl.mode.class = 'FlPDEWBoundary';
appl.assignsuffix = '_wb';
clear bnd
bnd.dweak = 'ut*test(u)';
bnd.weak = 'surfint2*test(u)';
bnd.ind = [1,1,1,1,1,1,1,1];
appl.bnd = bnd;
fem.appl{1} = appl;
fem.border = 1;
fem.outform = 'weak';

% Coupling variable elements
clear elemcpl
% Integration coupling variables
clear elem
elem.elem = 'elcplscalar';
elem.g = {'1'};
src = cell(1,1);
clear bnd
bnd.expr = {{ ...
  '-1/(2*pi)*u*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  '1/(2*pi)*u*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  {'u/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2))', ...
  'u/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2))'},{ ...
  'u*(x-dest(x))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(x-dest(x))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  'u*(y-dest(y))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(y-dest(y))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  'u*(z-dest(z))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  'u*(z-dest(z))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}, ...
  { ...
  '(Ex*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nx*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ex*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nx*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ey*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-ny*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ey*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-ny*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ez*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nz*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ez*(nx*(x-dest(x))+ny*(y-dest(y))+nz*(z-dest(z)))-nz*(Ex*(x-dest(x))+Ey*(y-dest(y))+Ez*(z-dest(z))))/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ey*nz-Ez*ny)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ey*nz-Ez*ny)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ez*nx-Ex*nz)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ez*nx-Ex*nz)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '(Ex*ny-Ey*nx)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)', ...
  '(Ex*ny-Ey*nx)/nonzero((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(1/2)'}, ...
  { ...
  '1/(2*pi)*u*(dest(nx)*(x-dest(x))+dest(ny)*(y-dest(y))+dest(nz)*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))', ...
  '-1/(2*pi)*u*(dest(nx)*(x-dest(x))+dest(ny)*(y-dest(y))+dest(nz)*(z-dest(z)))/nonzero(((x-dest(x))^2+(y-dest(y))^2+(z-dest(z))^2)^(3/2))'}};
bnd.ipoints = {{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4', ...
  '4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'},{'4','4'}};
bnd.frame = {{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz', ...
  'xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'},{'xyz','xyz'}, ...
  {'xyz','xyz'},{'xyz','xyz'}};
bnd.ind = {{'1','2','3','4','5','6','7'},{'8'}};
src{1} = {{},{},bnd,{}};
elem.src = src;
geomdim = cell(1,1);
clear bnd
bnd.usage = {{},{},{},{},{},{},{},{},{},{},{},{'1'}};
bnd.ind = {{'1','2','3','4','5','6','7','8'}};
geomdim{1} = {{},{},bnd,{}};
elem.geomdim = geomdim;
elem.var = {'surfint','phi','Ex','Ey','Ez','E2x','E2y','E2z','Hx','Hy', ...
  'Hz','surfint2'};
elem.global = {'1','2','3','4','5','6','7','8','9','10','11'};
elem.maxvars = {};
elemcpl{1} = elem;
fem.elemcpl = elemcpl;

% Functions
clear fcns
fcns{1}.type='inline';
fcns{1}.name='nonzero(x)';
fcns{1}.expr='((x)+((x)==0))';
fcns{1}.dexpr={'1'};
fcns{1}.complex='true';
fem.functions = fcns;

% Multiphysics
fem=multiphysics(fem);

% Extend mesh
fem.xmesh=meshextend(fem, ...
                     'linshape',[]);

% Solve problem
fem.sol=femeig(fem, ...
               'nullfun','flspnull', ...
               'complexfun','on', ...
               'solfile','on', ...
               'conjugate','on', ...
               'solcomp',{'u'}, ...
               'outcomp',{'u'}, ...
               'blocksize','auto', ...
               'neigs',1, ...
               'shift',1, ...
               'linsolver','spooles', ...
               'preorder','mmd');

% Save current fem structure for restart purposes
fem0=fem;

% Plot solution
postplot(fem, ...
         'tridata',{'u','cont','internal'}, ...
         'trimap','Rainbow', ...
         'title','lambda(1)=0.823528    Boundary: u', ...
         'grid','on', ...
         'campos',[14.181354109449247,1.9727854894576364,9.670959245521763], ...
         'camtarget',[-0.02748169951633644,0.014829379249172181,-0.03859238286807458], ...
         'camup',[-0.1159819874353235,0.9927838168204198,-0.03047083277548463], ...
         'camva',15.32568175057);
